<MorpheusModel version="4">
    <Description>
        <Title>Example-CircleDance</Title>
        <Details>Demonstration of dynamically regulated cell-cell adhesion as a function of changing cell properties.
        
        Date: May 8, 2020
            
        Author: joern.starruss@tu-dresden.de
            
        Software: Morpheus (open-source), download from https://morpheus.gitlab.io  
        </Details>
    </Description>
    <Global>
        <Constant symbol="adhesive_d" value="0.0"/>
    </Global>
    <Space>
        <SpaceSymbol symbol="l"/>
        <Lattice class="square">
            <Size symbol="size" value="200, 200, 0"/>
            <BoundaryConditions>
                <Condition type="periodic" boundary="x"/>
                <Condition type="periodic" boundary="y"/>
            </BoundaryConditions>
            <Neighborhood>
                <Order>2</Order>
            </Neighborhood>
        </Lattice>
    </Space>
    <Time>
        <StartTime value="0"/>
        <StopTime value="12000"/>
        <RandomSeed value="0"/>
        <TimeSymbol symbol="time"/>
    </Time>
    <CellTypes>
        <CellType class="biological" name="ct1">
            <VolumeConstraint target="200" strength="1"/>
            <Property symbol="contact_length" value="0.0"/>
            <NeighborhoodReporter>
                <Input value="cell.type == celltype.ct1.id" scaling="length"/>
                <Output symbol-ref="contact_length" mapping="sum"/>
            </NeighborhoodReporter>
            <Property symbol="contact_fraction" value="0"/>
            <Equation symbol-ref="contact_fraction">
                <Expression>contact_length / cell.surface</Expression>
            </Equation>
            <Property symbol="adhesive" value="0.0"/>
            <System solver="adaptive45">
                <DiffEqn symbol-ref="adhesive">
                    <Expression>0.05*(1-contact_fraction) - 0.01 * adhesive</Expression>
                </DiffEqn>
            </System>
            <Equation symbol-ref="adhesive_d">
                <Expression>adhesive</Expression>
            </Equation>
            <DelayProperty delay="500" name="adhesive concentration in Membrane, delayed due to transport." symbol="adhesive_d" value="0.0"/>
        </CellType>
        <CellType class="medium" name="medium"/>
    </CellTypes>
    <CPM>
        <Interaction default="0.0">
            <Contact type1="ct1" value="6" type2="medium"/>
            <Contact type1="ct1" value="16" type2="ct1">
                <HomophilicAdhesion strength="-3.0" adhesive="adhesive_d"/>
            </Contact>
        </Interaction>
        <MonteCarloSampler stepper="edgelist">
            <MCSDuration value="1"/>
            <Neighborhood>
                <Order>2</Order>
            </Neighborhood>
            <MetropolisKinetics temperature="2"/>
        </MonteCarloSampler>
        <ShapeSurface scaling="norm">
            <Neighborhood>
                <Order>6</Order>
            </Neighborhood>
        </ShapeSurface>
    </CPM>
    <CellPopulations>
        <Population type="ct1" size="0">
            <InitCircle number-of-cells="50" mode="random">
                <Dimensions center="size.x/2, size.y/2, 0" radius="size.x/3"/>
            </InitCircle>
        </Population>
    </CellPopulations>
    <Analysis>
        <Gnuplotter decorate="true" time-step="100">
            <Terminal name="png"/>
            <Plot>
                <Cells value="adhesive_d" flooding="true">
                    <ColorMap>
                        <Color value="3" color="red"/>
                        <Color value="1.5" color="yellow"/>
                        <Color value="0" color="white"/>
                    </ColorMap>
                </Cells>
            </Plot>
            <!--    <Disabled>
        <Plot>
            <Cells value="contact_fraction" flooding="true"/>
        </Plot>
    </Disabled>
-->
        </Gnuplotter>
        <DependencyGraph reduced="false" format="svg"/>
    </Analysis>
</MorpheusModel>
